using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;
using ParkhausGDI;
using System.Drawing;
using System.Linq;

namespace Parkhaus
{
    class Parkhaus
    {
        #region Variables
        private int _n;
        private int _maxPlatze;
        protected Semaphore _anzahlPlaetze;
        protected object _locker = new object();
        ICallbackHandler _GDIParkhaus;
        List<Auto> _parkingList;
        #endregion

        #region Constructors
        public Parkhaus(int p, ICallbackHandler GDIParkhaus)
        {
            _maxPlatze = p;
            _n = p;
            _anzahlPlaetze = new Semaphore(p, p);
            _GDIParkhaus = GDIParkhaus;
            _parkingList = new List<Auto>(p);
            for (int i = 0; i < p; i++)
            {
                _parkingList.Add(null);    
            }
        }
        #endregion

        public void Passieren(Auto car)
        {
            _anzahlPlaetze.WaitOne();
            lock (_locker)
            {
                _n--;
                for (int i = 0; i < _maxPlatze; i++)
                {
                    if (_parkingList[i] == null)
                    {
                        _parkingList[i] = car;
                        break;
                    }
                }
                object a = new object[] { _n, _parkingList };
                _GDIParkhaus.Handle(a);
            }
        }

        public void Verlassen(Auto car)
        {
            lock (_locker)
            {
                _n++;
                for (int i = 0; i < _parkingList.Count; i++)
                {
                    if (_parkingList[i] == car)
                    {
                        _parkingList[i] = null;
                    }
                }
                _GDIParkhaus.Handle(new object[] { _n, _parkingList });
            }
            _anzahlPlaetze.Release();
        }

        public int AnzahlPlaetze()
        {
            lock (_locker)
            {
                return _n;
            }
        }

        public int MaxPlaetze()
        {
            return _maxPlatze;
        }
    }
}
